<?php
 /**
     * Plugin Name: Eco Agenda
     * Description: Permet l'affichage d'un mini agenda contenant des évènements. Mises à jour automatique chaque jour avec le site www.eco-sorties.fr
     * Author: WISECO48
     * Version: 1.0.6
	 * Author URI: https://www.eco-sorties.fr/
     */

    /**
     * Copyright 2018-2023 Wis-IT, Kyubeek.
	 */
    define('ECO_AGENDA_DIR', plugin_dir_path(__FILE__));
    define('ECO_AGENDA_URL', plugin_dir_url(__FILE__));

    register_activation_hook(__FILE__, array('Eco_Mini_Agenda', 'install')); //procédure d'installation des tables
    register_uninstall_hook(__FILE__, array('Eco_Mini_Agenda', 'uninstall')); //procédure de désinstallation des tables

    class Eco_Agenda {
      public function __construct(){
        require_once ECO_AGENDA_DIR.'includes/eco_functions.php'; //l'inclus les fonctions dans la page
        require_once ECO_AGENDA_DIR.'eco_front.php'; //l'inclus les fonctions dans la page
        require_once ECO_AGENDA_DIR.'eco_admin.php'; //l'inclus les fonctions dans la page
        include_once ECO_AGENDA_DIR.'eco_mini_agenda.php'; //inclus le widget mini agenda
        new Eco_Mini_Agenda();
      }
    }
    new Eco_Agenda();

    add_action("admin_menu", "eco_widget_add_admin_item"); //ajout du texte dans le menu

    //add_action("the_post", "eco_widget_text"); 
	//insertion du plugin dans la page principale
    //add_action('eco',"eco_widget_text");
?>
