<?php
// Définition de la fonction qui permet d'ajouter l'icône dans la barre des paramètres
function eco_widget_add_admin_item()
{
    add_menu_page(
        'Configuration du module eco-sorties',       // Titre de la page
        'Eco Agenda',                                // Texte à afficher dans la barre de configuration
        'manage_options',                            // Autorisation requise pour voir le lien
        ECO_AGENDA_DIR.'includes/eco_admin.php',     // Lien attaché
        'eco_agenda_admin',                          // Fonction à lancer
        null,                                        // Icône à attribuer
        82                                           // Position dans la barre de configuration
    );
}


function eco_agenda_admin() //affichage de l'administration
{
  global $wpdb;
  echo '<h2>Administration d\'Eco Agenda</h2>';
  echo '<form action="" method="POST">';
  if(isset($_POST['securite_nonce'])) {
    if(wp_verify_nonce($_POST['securite_nonce'], 'securite-nonce')) { //contrôle de la clef de sécurité
      if(!empty($_POST['save'])){ //on sauvegarde les paramètres
        $error = set_param('onecode',$_POST['onecode'],'');
        $error .= set_param('couleur_mod',$_POST['fonce'],$_POST['clair']);
        $error .= set_param('affiche_mod',$_POST['max'],'');
        if($error == ''){echo '<div class="notice notice-success is-dismissible"><p>Paramètres mis à jour !</p></div>';}else{echo $error;}
      }

      if(!empty($_POST['maj'])){ //on force une maj
        echo load_agenda('back');
      }

    } else {
      echo '<div class="notice notice-error is-dismissible"><p>Erreur dans le formulaire</p></div>';
    }
    //echo '<hr/>';
  }

  $p_onecode = get_param('onecode'); //récup des infos
  echo '<strong>Onecode : </strong><input type="text" name="onecode" value="'.$p_onecode->val_1.'">
  <input type="submit" name="save" class="button button-primary" value="Enregistrer"><br/>';
  $p_affiche_mod = get_param('affiche_mod'); //récup des infos
  echo '<strong>Nombre max d\'affichage : </strong><input type="text" size="1" name="max" value="'.$p_affiche_mod->val_1.'"><br/>';
  $p_couleur = get_param('couleur_mod'); //récup des infos
  echo 'Couleur foncé : <input type="color" size="7" name="fonce" value="'.$p_couleur->val_1.'">
    Couleur clair : <input type="color" size="7" name="clair" value="'.$p_couleur->val_2.'"><br/><br/>';

  echo '<hr/>';
  $p_date = get_param('date'); //récup des infos
  echo '<strong>Dernière MAJ : </strong>'.convert_date($p_date->val_1).' ';
  echo '<input type="submit" name="maj" class="button button-primary" value="Mettre à jour">';
  echo '<input type="hidden" name="securite_nonce" value="'.wp_create_nonce('securite-nonce').'"/></form>';

  //en cours de développement
  echo '<p><strong>Paramètrage du service a titre informatif</strong></p>';
  $p_categorie = get_param('categorie'); //récup des infos

  $p_localisation = get_param('localisation'); //recup des infos
  if($p_localisation->val_2 == ''){ //si pas de parc
    echo '<strong>Périmètre : </strong>'.$p_localisation->val_1.' km<br/>';
  }
  else {
    echo '<strong>Parc : </strong>'.$p_localisation->val_2.'<br/>';
  }
  echo '<strong>Date de validité : </strong>'.convert_date($p_date->val_2).'<br/>';

  echo '<strong>Catégories :</strong>';
  $tab_cat = explode(',',$p_categorie->val_1);
  $cat_auto = explode(',',$p_categorie->val_2);
  echo '<table><tr><td>';
  foreach($tab_cat as $k => $cat){
    $k = $k+1;
    echo '<input disabled type="checkbox"'; if(in_array($k,$cat_auto)){echo ' checked';} echo '/>'.$cat.'<br/>';
    if($k == 8 || $k == 16 || $k == 24 || $k == 32 || $k == 40){echo '</td><td>';}
  }
  echo '</td></tr></table>';
  echo '</p>';
  echo '<hr/>';
  echo '<p><img style="float:left;" src="'.ECO_AGENDA_URL.'includes/img/eco-sorties.png" alt="eco-sortie" title="Eco Sorties"/><strong>L’extension Eco Agenda est liée au site web éco-sorties.fr.</strong></p>
  <p>
Eco-sorties est une plateforme multi-canal qui centralise et diffuse les manifestations et évènements touristique de votre département, région.
Le mini-agenda est l’un des vecteurs de diffusion, l’installation de l’extension sur votre site web  vous permettra de disposer de ces informations.</p>
<p>Pour rendre le mini-agenda fonctionnel vous devez demander la création d’un compte utilisateur pour obtenir un onecode.<br/>
Lors de la création de votre compte vous pourrez définir une zone géographique et les catégories d’évènements que vous souhaitez avoir sur votre page web.</p>
<p>Attention ce service est payant, pour plus d\'information merci de vous rendre sur <a target="_blank" href="https://www.eco-sorties.fr/demande-inscription.html">www.eco-sorties.fr</a></p>';
}
