<?php
    class Eco_Mini_Agenda {
      public function __construct(){
        add_action('widgets_init', function(){register_widget('Eco_Mini_Agenda_Widget');}); //initialisation du mini agenda
      }

      public static function install(){
        global $wpdb;
        $charset_collate = $wpdb->get_charset_collate();
        $table_name = $wpdb->prefix.'eco_param';
        $sql = "CREATE TABLE IF NOT EXISTS $table_name (
          id_p int(6) NOT NULL AUTO_INCREMENT,
          nom_p varchar(254) NOT NULL,
          val_1 text NOT NULL,
          val_2 text NOT NULL,
          PRIMARY KEY  (id_p)
        ) $charset_collate;";
        $wpdb->query($wpdb-> prepare($sql,''));

        $wpdb->insert($table_name,array('nom_p' => 'onecode','val_1' => '',	'val_2' => ''));
        $wpdb->insert($table_name,array('nom_p' => 'couleur_mod','val_1' => '#d8f0c7',	'val_2' => '#ffffff'));
        $wpdb->insert($table_name,array('nom_p' => 'affiche_mod','val_1' => '4',	'val_2' => ''));
        $wpdb->insert($table_name,array('nom_p' => 'localisation','val_1' => '10',	'val_2' => ''));
        $wpdb->insert($table_name,array('nom_p' => 'date','val_1' => '0000-00-00',	'val_2' => '0000-00-00'));
        $wpdb->insert($table_name,array('nom_p' => 'categorie','val_1' => 'Animation | Fête,Autre,Bal | Disco,Brocante | Vide-grenier,Concert | Spectacle,Concours,Conférence | Débat,Culture,Découverte | Visite guidée,Exposition | Salon,Festival,Foire | Marché,Loto | Quine,Loisirs | Détente,Marche | Randonnée,Randonnée équestre,Randonnée VTT,Soirée,Sport - Championnat,Stage | Atelier,Théâtre,Nature,Cyclotourisme,Projection | Cinéma,Eco-Citoyen,Contes | Rencontres,Cirque | Art de la rue,Patrimoine,Hors Stade,Sport Mécanique (HES),Conseil Municipal,Services itinérant,Travaux,Bien-être,Cours',	'val_2' => ''));

        $table_name = $wpdb->prefix.'eco_agenda';
        $sql = "CREATE TABLE IF NOT EXISTS $table_name (
          id_ea int(11) NOT NULL AUTO_INCREMENT,
          id_e int(11) NOT NULL,
          titre varchar(200) NOT NULL,
          date_d date NOT NULL,
          heure_d time NOT NULL,
          date_f date NOT NULL,
          heure_f time NOT NULL,
          adresse varchar(100) NOT NULL,
          gps_lat double NOT NULL,
          gps_lon double NOT NULL,
          mail varchar(100) NOT NULL,
          site varchar(200) NOT NULL,
          phone varchar(20) NOT NULL,
          tarifs float NOT NULL DEFAULT '0',
          vignette varchar(200) NOT NULL,
          description mediumtext,
          IDcommune int(6) NOT NULL,
          COtitre varchar(100) NOT NULL,
          IDdepartement varchar(3) NOT NULL,
          DEtitre varchar(100) NOT NULL,
          IDregion int(2) NOT NULL,
          IDtype int(3) NOT NULL,
          Ttitre varchar(100) NOT NULL,
          PRIMARY KEY  (id_ea)
        ) $charset_collate;";
        $wpdb->query($wpdb-> prepare($sql,''));
      }

      public static function uninstall(){
        global $wpdb;
        $table_name = $wpdb->prefix.'eco_param';
        $sql = "DROP TABLE IF EXISTS $table_name";
        $wpdb->query($wpdb-> prepare($sql,''));

        $table_name = $wpdb->prefix.'eco_agenda';
        $sql = "DROP TABLE IF EXISTS $table_name";
        $wpdb->query($wpdb-> prepare($sql,''));
      }

    }

    class Eco_Mini_Agenda_Widget extends WP_Widget{
      public function __construct(){
        parent::__construct('Eco_Mini_Agenda','Eco Agenda',array('description' => 'Un calendrier des évènements synchronisé avec Eco-sorties '));
        add_action('wp_enqueue_scripts', array($this, 'my_java_css'));
      }

      function my_java_css() {
          wp_enqueue_script('jquery');
          wp_enqueue_script('jquery-ui-core');
          wp_enqueue_style('mini-agenda-style', ECO_AGENDA_URL.'includes/css/style.css');
      }

      public function widget($args, $instance)
      {
        echo $args['before_widget'];
        echo $args['before_title'];
        echo apply_filters('widget_title', $instance['title']);
        echo $args['after_title'];
        echo load_agenda('front');
        if(file_exists(ECO_AGENDA_DIR.'includes/cache/mini_agenda.html')){
          include_once(ECO_AGENDA_DIR.'includes/cache/mini_agenda.html');
        }else {
          echo '<p style="color:red;">Configurer le module dans l\'administration</p>';
        }
        echo $args['after_widget'];
      }
    }
?>
