<?php

function load_agenda($lieu){ //en fonction du lieu d'appel il y a des différences back = administration / front = site
  $onecode = get_param('onecode');
  $date = get_param('date'); //je récupère le onecode et la date de maj
  if($onecode->val_1 == ''){
    if($lieu == 'back'){
      return '<div class="notice notice-error is-dismissible"><p>Enregistrer votre Onecode pour effectuer une Mise à jour</p></div>';
    }else {
      return '<div class="notice notice-error is-dismissible"><p>Configurer le module en administration</p></div>';
    }
  }
  else {
    if($date->val_1 < date("Y-m-d") || $lieu == 'back'){ //est ce que l'on met à jour les events ?
      $events = maj_bdd($onecode->val_1); //on va chercher les informations sur le site eco-guides
      if($events == false){
        if($lieu == 'back'){return '<div class="notice notice-error is-dismissible"><p>Erreur de connexion</p></div>';}
      }else {
        $events = explode('|INFOS|', $events);
        set_events($events[0]); //on pousse les events dans la bdd
        $infos = explode(';', $events[1]);
        set_param('localisation',$infos[0],$infos[1]);
        set_param('date',date("Y-m-d"),$infos[2]); //maj des données
        set_param('categorie',$infos[3],$infos[4]);
        $mini_agenda = gen_mini_agenda($onecode->val_1); //on génère le mini agenda
        //var_dump(ECO_AGENDA_DIR.'includes\cache\mini_agenda.html');
        cache($mini_agenda, ECO_AGENDA_DIR.'includes/cache/mini_agenda.html'); //mise en cache du mini agenda
        if($lieu == 'back'){return '<div class="notice notice-success is-dismissible"><p>La mise a jour a bien été effectué</p></div>';}
      }
    }
  }
}

function cache($mini_agenda,$fichier){
    $cache = fopen($fichier,'w+'); //ouverture du fichier
		fwrite($cache, $mini_agenda); //ajout des informations
		fclose($cache); //fermeture du fichier
	}

	function maj_bdd($onecode){
    //récupération des informations en fonction du one code depuis la page eco-sorties
    $page = wp_remote_get('https://www.eco-sorties.fr/consultation.php?oc='.$onecode);
    $page = sanitize_text_field($page['body']);
    if(substr($page, 0, 1) != '('){ //si on a pas réussi a récupérer les informations
			return false;
		}
		else{
			return $page;
		}
	}

	function set_events($events){
		global $wpdb;
		$wpdb->get_results("TRUNCATE TABLE {$wpdb->prefix}eco_agenda"); //on vide la table des données

		//on charge les données dans la tables
		$wpdb->get_results("INSERT INTO  {$wpdb->prefix}eco_agenda (id_e, titre, date_d, heure_d, date_f, heure_f, adresse, gps_lat, gps_lon, mail, site, phone, tarifs, vignette, description, IDcommune, COtitre, IDdepartement, DEtitre, IDregion, IDtype, Ttitre) VALUE ".$events);
	}

	function get_events($sql_date){
		global $wpdb; //connexion a la bdd
		$req = "SELECT * FROM {$wpdb->prefix}eco_agenda WHERE date_d <= '".$sql_date."' AND date_f >= '".$sql_date."' ORDER BY heure_d";
		$infos = $wpdb->get_results($req);
		return $infos;
	}

	function set_param($nom_p, $val_1, $val_2){
		global $wpdb;
    //je test si le paramètre est déjà renseigné
    $params = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'eco_param WHERE nom_p = "'.$nom_p.'"');
    foreach($params as $param){}
    if($param == NULL){ //le paramètre n'existe pas donc on l'insère
      $wpdb-> query($wpdb-> prepare('INSERT INTO '.$wpdb->prefix.'eco_param SET nom_p = %s, val_1 = %s, val_2 = %s',array(sanitize_text_field($nom_p),sanitize_text_field($val_1),sanitize_text_field($val_2))));
    }else{ //le paramètre existe donc on update
      $wpdb-> query($wpdb-> prepare('UPDATE '.$wpdb->prefix.'eco_param SET val_1 = %s, val_2 = %s WHERE nom_p = "'.$nom_p.'"',array(sanitize_text_field($val_1),sanitize_text_field($val_2))));
    }

    //vérification des erreurs
    if($wpdb->last_error == ""){
      $return = '';
    }else{
      $return = '<div class="notice notice-error is-dismissible"><p>Erreur : '.$wpdb->last_error.'</p></div>';
    }
    return $return;
	}

	function get_param($nom_p){
		global $wpdb; //connexion a la base pour récupérer le ONECODE
		$params = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'eco_param WHERE nom_p = "'.$nom_p.'"');
    foreach($params as $param){}
		return $param;
	}

  function convert_date($date){ //transforme une date 'fr' en une date 'en' et inversement
		if($date != '')
		{
			$tab = explode('-',$date);
			$date_r = $tab[2].'-'.$tab[1].'-'.$tab[0];
			return $date_r;
		}
	}

  function gen_mini_agenda($onecode){ //ici on commence la construction du mini agenda

      $return = '<div id="agenda">';

  		for ($m = 0; $m < 12; $m++) //je charge une année complète
  		{
  			$parc = 0;
  			$eco_g = 'https://www.eco-sorties.fr/?option=com_calendar';
  			setlocale(LC_TIME,'fr','fr_FR','fr_FR.ISO8859-1');
  			$str_date = date('m/d/Y',strtotime(date("Y-m") . "+".$m." month"));

  			$y = substr($str_date, 6, 10);  //année
  			$num_m = substr($str_date, 0, 2); //numéro du mois

  			$start = mktime(0,0,0,date($num_m), date(1), date($y)); //voici le premier jour du mois
  			$nend = date("t",$start);  	$nstart = date("N",$start); //attention need PHP 5.1.0

  			$return .= '<span class="Month">';

  			$return .= '<table cellspacing="0" cellpadding="0">
  			<tr>
  				<td colspan="7" class="titre_d">';
          if($m != 0){$return .= '<button class="left" onclick="plusDivs(-1)">&#10094;</button>';} //bouton précédent
          $return .= utf8_encode(ucfirst(strftime("%B %Y", strtotime($str_date)))); //on affiche le mois
          if($m != 11){$return .= '<button class="right" onclick="plusDivs(1)">&#10095;</button></td>';} //bouton suivant
  			$return .= '</tr>
  			<tr class="jour">
  				<td>Lun</td><td>Mar</td><td>Mer</td><td>Jeu</td><td>Ven</td><td>Sam</td><td>Dim</td>
  			</tr>
  			<tr class="date">';
  			for($v = 1; $v < $nstart; $v++){$return .= '<td></td>';}	//je commence a remplir de case vide
  			for($i = 1; $i <= $nend; $i++)						//il faut calculer le début a la bonne place
  			{
  				//ici je vais chercher les évènements présents ce jour ci
  				if($i < 10){$j = '0'.$i;}else{$j = $i;}
  				$sql_date = $y.'-'.$num_m.'-'.$j; $fr_date = $j.'-'.$num_m.'-'.$y; //définition des dates pour leur utilisation

  				$rows = get_events($sql_date);
          //var_dump($rows);
  				$nbm = count($rows);
  				if($nbm != 0)
  				{

  					$date = strftime("%A %d %B", strtotime($num_m.'/'.$j.'/'.$y));
  					$max_m = 1; //gestion de l'affichage max de manif
  					$popup = '<div id="popup'.$m.$i.'" class="popup_block"><a class="titre_d center upper marron" target="_blank" href="'.$eco_g.'&amp;s=Rechercher&amp;parc='.$parc.'&amp;date_d='.$fr_date.'&amp;date_f='.$fr_date.'">'.utf8_encode($date).' : </a>';
  					foreach($rows as $s)
  					{
  						/*if($s->date_d'] == $s->date_f']) //on est sur un évènement d'une seule journée
  						{

  							$tab = explode('-',$s->date_d']); $date_d = $tab[2].'-'.$tab[1].'-'.$tab[0]; // fonction convert_date
  							$date = 'Le '.$date_d.'<br/>';
  							if($s->heure_d'] != '00:00:00')
  							{
  								if($s->heure_f'] != '00:00:00')
  								{
  									$date .= ' de '.str_replace(array(':00:00',':00',':'),array('h','','h'),$s->heure_d']).' à '.str_replace(array(':00:00',':00',':'),array('h','','h'),$s->heure_f']);
  								}
  								else
  								{
  									$date .= ' a partir de '.str_replace(array(':00:00',':00',':'),array('h','','h'),$s->heure_d']);
  								}
  							}
  						}
  						else //on est sur un évènement de plusieurs jours
  						{
  							$tab = explode('-',$s->date_d']); $date_d = $tab[2].'-'.$tab[1].'-'.$tab[0]; // fonction convert_date
  							$tab = explode('-',$s->date_f']); $date_f = $tab[2].'-'.$tab[1].'-'.$tab[0]; // fonction convert_date
  							$date = 'Du '.$date_d.' au '.$date_f;
  						}*/
              if($s->heure_d == "00:00:00"){
                $heure_deb = 'Toute la journée'; //début de l'évènement.
              }else{
                $heure_deb = 'A partir de '.str_replace(array(':00:00',':00',':'),array('h','','h'),$s->heure_d); //début de l'évènement.
              }

  						if($s->adresse != ''){
  							$lieu = $s->adresse;
  						}else{
  							$lieu = $s->COtitre;
  						}
              $couleur = get_param('couleur_mod');
              if($max_m%2 == 1){$color = $couleur->val_1;}else{$color = $couleur->val_2;}
              //if($max_m%2 == 1){$color = 'fonce';}else{$color = 'clair';}
  						$popup .= '<p style="background-color:'.$color.'"><a class="upper noir" target="_blank" href="'.$eco_g.'&amp;e='.$s->id_e.'"><u>'.$s->titre.'</u></a>
  								<a class="noir" target="_blank" href="'.$eco_g.'&amp;e='.$s->id_e.'"><img src="'.ECO_AGENDA_URL.'includes/img/date.png" alt="informations"/>'.$heure_deb.'<br/><img src="'.ECO_AGENDA_URL.'includes/img/map.png" alt="informations"/>'.$lieu.'</a></p>';
  						/*$popup .= <tr>
  							<td><img src="'.JURI::Root().'modules/mod_agendaCalendar/img/date_min.png" alt="date"/></td>
  							<td><a class="texte gris" target="_blank" href="'.$eco_g.'&amp;s=Rechercher&amp;parc='.$parc.'&amp;date_d='.$j.'-'.$num_m.'-'.$y.'&amp;date_f='.$j.'-'.$num_m.'-'.$y.'"> '.$date.'</a></td>
  						</tr>-->
  						<!--<tr>
  							<td><img src="'.JURI::Root().'modules/mod_agendaCalendar/img/map_min.png" alt="map"/></td>
  							<td><a class="texte noir" target="_blank" href="'.$eco_g.'&parc=0&reg='.$s->IDregion'].'&dep='.$s->IDdepartement'].'&com='.$s->IDcommune'].'&s=Rechercher">'.$s->COtitre'].'</a><a class="texte gris" target="_blank" href="'.$eco_g.'&parc=0&reg='.$s->IDregion'].'&dep='.$s->IDdepartement'].'&s=Rechercher">'.str_replace(0,'',$s->IDdepartement']).' '.$s->DEtitre'].'</a></td>
  						</tr>*/

              $affiche_max = get_param('affiche_mod');
  						if($max_m == $affiche_max->val_1){break;}else{$max_m++;} //limitation du nombre max de manifestations affichés
  					}

  					$popup .= '<a class="vert" target="_blank" href="'.$eco_g.'&amp;s=Rechercher&amp;o='.base64_encode ($onecode).'&amp;date_d='.$j.'-'.$num_m.'-'.$y.'&amp;date_f='.$j.'-'.$num_m.'-'.$y.'">AU TOTAL&nbsp;:&nbsp;'.$nbm.'&nbsp;Manifestation';
  					if($nbm > 1){$popup .= 's';} //gestion du pluriel
  					$popup .= '<br/><span class="marron">:: Voir la journée</span>';
  					$popup .= '</div>';

  					$return .= '<td bgcolor="#8cb942">'.$popup.'<a data-width="320" class="poplight" data-rel="popup'.$m.$i.'" href="#">'.$i.'</a></td>';
  				}
  				else
  				{
  					$return .= '<td>'.$i.'</td>';
  				}

  				if((($i+$v) == 8) || (($i+$v) == 15) || (($i+$v) == 22) || (($i+$v) == 29) || (($i+$v) == 36)){$return .= '</tr><tr class="date">';} //on fait un retour a la ligne
  			}

  			//je calcule le nombre de case vide a remplir
  			$tc = (($v-1) + $nend);
  			if($tc == 28){$v2 = 28-$tc;} //4 ligne
  			if($tc > 28 && $tc <= 35){$v2 = 35-$tc;} //5 ligne
  			if($tc > 35){$v2 = 42-$tc;} //6 ligne
  			for($i = 1; $i <= $v2; $i++){$return .= '<td></td>';}		//je fini de remplir de case vide
  			$return .= '</tr></table>';


  			$return .= '</span>';
  		} //fin du for


  			$return .= '</div>';


  	$return .= "<script>
  		jQuery(document).ready(function($) {
  			$('a.poplight').on('click', function() {
  				var popID = $(this).data('rel'); //Trouver la pop-up correspondante
  				var popWidth = $(this).data('width'); //Trouver la largeur

  				$('#' + popID).fadeIn().css({ 'width': popWidth}).prepend('<a href=\"#\" class=\"close\"><img src=\"".ECO_AGENDA_URL."includes/img/close.png\" class=\"btn_close\" title=\"Fermer la fenêtre\" alt=\"Close\" /></a>');

  				var popMargTop = ($('#' + popID).height()) / 2;
  				var popMargLeft = ($('#' + popID).width()) / 2;

  				//Apply Margin to Popup
  				$('#' + popID).css({
  					'margin-top' : -popMargTop,
  					'margin-left' : -popMargLeft
  				});

  				$('body').append('<div id=\"fade\"></div>');
  				$('#fade').css({'filter' : 'alpha(opacity=80)'}).fadeIn();

  				return false;
  			});

  			$('body').on('click', 'a.close, #fade', function() { //Au clic sur le body...
  				$('#fade , .popup_block').fadeOut(function() {
  					$('#fade, a.close').remove();
  			});
  				return false;
  			});
  		});

  		var slideIndex = 1;
  		showDivs(slideIndex);

  		function plusDivs(n) {
  			showDivs(slideIndex += n);
  		}

  		function showDivs(n) {
  			var i;
  			var x = document.getElementsByClassName(\"Month\");
  			if (n > x.length) {slideIndex = 1}
  			if (n < 1) {slideIndex = x.length}
  			for (i = 0; i < x.length; i++) {
  				x[i].style.display = \"none\";
  			}
  			x[slideIndex-1].style.display = \"block\";
  		}
  		</script>";

  		return $return;

  	}
